package server;

/**
 * <p>Title: Ʈp Ʈ д ּҴ</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

import java.io.*;
import java.net.*;
import util.Clock;
import network.UserInterface;
import network.NetworkInterface;
import transmission.exception.IllegalMajorVersionException;


public class Unit implements UnitInterface
{
  private int m_serialNumber = -1; // ϴ Ŭ̾Ʈ  ȣ
  private String m_id = null; //̵
  private byte m_roomNo = (byte)-1; //ȣ

  /*
    Unit  Ῡ.
    Unit / UnitSender  Ҵɻ° ȴ
  */
  private boolean m_isAlive = true;

  private ServerInterface m_serverService = null; /* Server  ̽ */
  private NetworkInterface m_netService = null; /*  /б  ̽ */
  private UserInterface m_rooms = null;/* äù   ̽ */
  private Socket m_soc = null; /* Ŭ̾Ʈ  */
  private InputStream m_in = null;  /*  д Ʈp Ʈ */
  private OutputStream m_out = null; /*  ϴ Ʈp Ʈ */

  //not use
  private Unit() {}

  /**
   * Unit ϰ
   * Ŭ̾Ʈ I/OƮ, , Ʈ ۸ ´
   *
   * @param s   Ŭ̾Ʈ 
   * @param i    /б  ̽
   * @param serveri Server  ̽
   * */
  public Unit(Socket soc, NetworkInterface i, UserInterface rooms, ServerInterface serveri)
  {
    m_soc = soc;
    m_netService = i;
    m_rooms = rooms;
    m_serverService = serveri;
  }

  /**
   * äýø ȣ 
   *
   * @param serial ȣ
   * */
  public void setSerialNum(int serial)
  {
    this.m_serialNumber = serial;
  }

  /***
   * äýø ȣ 
   *
   * @return int ȣ
   */
  public int getSerialNum()
  {
    return m_serialNumber;
  }

  /**
   * Unit ̵ 
   *
   * @return String ̵
   * */
  public String getId()
  {
    return m_id;
  }

  /**
   * Unit ̵ 
   *
   * @param id ̵
   * */
  public void setId(String id)
  {
    m_id = id;
  }

  /**
   * ä ȣ 
   *
   * @param no ȣ
   * */
  public void setRoomNo(byte no)
  {
    m_roomNo = no;
  }

  /**
   * ä ȣ 
   *
   * @return byte ȣ
   * */
  public byte getRoomNo()
  {
    return m_roomNo;
  }

  /**
   * Unit  
   *
   * @return boolean ۰
   * */
  public final boolean startService()
  {
    m_isAlive = true;

    try
    {
      m_in = m_soc.getInputStream();
      m_out = m_soc.getOutputStream();
    }
    catch(IOException e)
    {
      m_isAlive = false;
      return false;
    }

    return true;
  }

  /**
   * Unit  On/Off θ ˷ش
   *
   * @return boolean true/false
   * */
  public final boolean isAlive()
  {
    return m_isAlive;
  }

  /**
   * Ŭ̾Ʈκ Ʈp Ʈ ѹ д´
   *
   * @return boolean 
   * */
  public boolean receive()
  {
    /* nAvailable Ʈ б 񽺰 ƴ ˻Ѵ */
    if (isAlive() == false) return false;

    /*
      receive() ó :
        Ŭ̾Ʈ ϴ Ʈ ð Time Out  ð 
        ð  Ŷ  ˻ϰ
         Ʈ Wait Time ̱
         Ʈ ٷ óѴ
    */

    /* [Notice !] available 0 ƴѰ ;Ѵ */
    byte available = (byte)0; /* ð ϱ  ù Ʈ */

    try
    {
      m_soc.setSoTimeout(5);
      available = new DataInputStream(getInputStream()).readByte();
    }
    catch(InterruptedIOException iter)
    {
      available = (byte)0; //ð ʰϿǷ ˻Ʈ ʱȭ
    }
    catch(IOException ioe)
    {
      clientLogout();  //if client, remove client info
      stopService(); /* Ʈ ̹Ƿ Unit 񽺸 Ѵ */
      return false;
    }

    /* Ʈ б  񽺰 ƴ ˻Ѵ */
    if (isAlive() == false) return false;

    /* ȿ ùƮ ˻Ѵ */
    //System.out.println("######## available ="+available);

    try
    {
      /*  Read Stream ó  TimeOut ʱȭѴ */
      m_soc.setSoTimeout(0);

      if (available == (byte)1)//VersionControl.getMajorVersion())
      {
        // 
        UnitSender unitSender = new UnitSender(this, available);
        //Ʈа 
        m_netService.sendFrame(unitSender);
        //˻Ʈ ʱȭ
        available = (byte)0;

        return true;
      }
      else if (available == (byte)0)
      {
        //˻Ʈ ʱȭ
        available = (byte)0;
        //Client Read  óϱ  receive() ȣ
        m_netService.receiveFrame(this);
        return true;
      }
      else
        throw new IllegalMajorVersionException("MajorVer="+available);
    }
    catch(Exception ioe)
    {
      System.out.println("Unit.IOException.ioe="+ioe.toString());
      stopService(); /* ߸ ѹ Ƿ Unit 񽺸 Ѵ */
      clientLogout(); //if client, remove client info

      return false;
    }
  }

  /**
   * Ŭ̾Ʈ α׾ƿ  ó
   * */
  protected final void clientLogout()
  {
    ChatRoom room = (ChatRoom)m_rooms.getClient(new Integer(m_roomNo));
    //For Debugging
    if (room != null)
    {
      System.out.println("clientLogout()  ȣ="+m_roomNo+", "+m_serialNumber+"  "+room.getUser(m_serialNumber)+" ̵="+m_id);
      boolean ret = room.removeClient(m_serialNumber);
    }

    //For Debugging
    //System.out.println("Ŭ̾Ʈ α׾ƿ ó   : "+room.getUsrList().length);
  }

  /**
   * Unit  
   *
   * 񽺸 ϰ,  Unit Ѵ
   * @return boolean 
   * */
  public boolean stopService()
  {
    //stop service
    if (m_isAlive == false) return true;
    m_isAlive = false;

    try
    {
      m_soc.setSoTimeout(0);

      if (m_soc != null) m_soc.close();
      if (m_in != null) m_in.close();
      if (m_out != null) m_out.close();
      m_soc = null;
      m_in = null;
      m_out = null;
    }
    catch(Exception e) {}

    System.out.println("Unit.stopService() called !");

    return !m_isAlive;
  }

  /**
   *  Ʈp Input Stream 
   *
   *  @return InputStream
   * */
  public final InputStream getInputStream()
  {
    return m_in;
  }

  /**
   *  Ʈp Output Stream 
   *
   *  @return OutputStream
   * */
  public final OutputStream getOutputStream()
  {
    return m_out;
  }

  /**
   * NetworkInterface 
   * @return NetworkInterface б/ ̽
   * */
  public final NetworkInterface getNetworkInterface()
  {
    return m_netService;
  }

  /**
   * äù  
   * @return UserInterface äù  ̽
   * */
  public final UserInterface getRooms()
  {
    return m_rooms;
  }

  public final ServerInterface getServerInterface()
  {
    return this.m_serverService;
  }

}